<template>
  <el-dialog
    :title="title"
    :visible.sync="open"
    width="70%"
    append-to-body
    :close-on-click-modal="false"
    @close="cancel"
  >
    <div class="form-dialog-box"
    v-loading="loading"
    :element-loading-text="loadingText"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0)">
      <div
        v-loading="loading"
        :element-loading-text="''"
        element-loading-spinner="''"
        element-loading-background="rgba(0, 0, 0, 0.8)"
        >
        <el-form :model="form" ref="form" :rules="rules" label-width="130px">
          <el-form-item label="标题名称" prop="titleName">
            <el-input style="width: 350px;" v-model="form.titleName" placeholder="请输入标题名称" maxlength="50" show-word-limit />
          </el-form-item>
          <el-form-item label="内容摘要" prop="contentMain">
            <el-input style="width: 350px;" v-model="form.contentMain" type="textarea" placeholder="请输入内容摘要" />
          </el-form-item>
          <el-form-item label="封面上传" prop="imgUrl">
            <div style="display: flex;">
              <div 
              v-for="(item,index) in form.imgUrl" 
              :key="index"
              style="width: 100px; height: 100px;position: relative;border: 1px solid #999;border-radius: 5px;margin-right: 20px;">
                <el-image 
                  style="width: 100%; height: 100%"
                  :src="item" 
                  :preview-src-list="form.imgUrl">
                </el-image>
                <span @click="handleRemove(index)" style="position: absolute;top: -15px;right: -15px;color: red;font-size: 24px;z-index: 999;cursor: pointer;">
                  <i class="el-icon-error"></i>
                </span>
              </div>
              <div 
              style="width: 100px; height: 100px;" 
              v-if="!form.imgUrl||form.imgUrl.length<5"
              v-loading="actionUrlLoading"
              element-loading-text="上传中..."
              element-loading-spinner="el-icon-loading"
              element-loading-background="rgba(0, 0, 0, 0.8)"
              >
                <el-upload
                  class="avatar-uploader"
                  :action="actionUrl"
                  :data="{
                    bucket: 'tourism'
                  }"
                  :show-file-list="false"
                  :before-upload="beforeAvatarUpload"
                  :on-success="handleAvatarSuccess"
                  :on-progress="handleAvatarProgress"
                  :disabled="actionUrlLoading"
                  :on-error="handleAvatarError"
                  >
                  <i class="el-icon-plus avatar-uploader-icon"></i>
                </el-upload>
              </div>
              
            </div>
            <span>支持jpg、png、gif,支持1MB大小以内的图片上传</span>
          </el-form-item>
          <el-form-item label="景区相册" prop="photos">
            <div style="display: flex;">
              <div 
              v-for="(item,index) in form.photos" 
              :key="index"
              style="width: 100px; height: 100px;position: relative;border: 1px solid #999;border-radius: 5px;margin-right: 20px;">
                <el-image 
                  style="width: 100%; height: 100%"
                  :src="item" 
                  :preview-src-list="form.photos">
                </el-image>
                <span @click="handleRemoveMore(index)" style="position: absolute;top: -15px;right: -15px;color: red;font-size: 24px;z-index: 999;cursor: pointer;">
                  <i class="el-icon-error"></i>
                </span>
              </div>
              <div 
              style="width: 100px; height: 100px;" 
              v-if="!form.photos||form.photos.length<20"
              v-loading="actionUrlMoreLoading"
              element-loading-text="上传中..."
              element-loading-spinner="el-icon-loading"
              element-loading-background="rgba(0, 0, 0, 0.8)"
              >
                <el-upload
                  class="avatar-uploader"
                  :action="actionUrl"
                  :data="{
                    bucket: 'tourism'
                  }"
                  :show-file-list="false"
                  :before-upload="beforeAvatarUploadMore"
                  :on-success="handleAvatarSuccessMore"
                  :on-progress="handleAvatarProgressMore"
                  :disabled="actionUrlMoreLoading"
                  :on-error="handleAvatarErrorMore"
                  >
                  <i class="el-icon-plus avatar-uploader-icon"></i>
                </el-upload>
              </div>
              
            </div>
            <span>支持jpg、png、gif,支持1MB大小以内的图片上传</span>
          </el-form-item>
          <el-form-item label="内容详情" prop="contentType">
            <el-radio-group v-model="form.contentType" @input="setContentType">
              <el-radio 
                v-for="dict in dict.type.tourism_attractionInfoIntroduce_type"
                :label="Number(dict.value)"
                >{{ dict.label }}</el-radio>
            </el-radio-group>
          </el-form-item>
          <el-form-item label=""  label-width="0" prop="content">
            <el-input v-if="form.contentType==2" style="width: 350px;" v-model="form.content" placeholder="请输入链接内容" />
            <editor ref="editor" v-if="form.contentType==1" v-model="form.content" :fileSize="20" :min-height="200" />
          </el-form-item>
        </el-form>
      </div>
    </div>
    <span slot="footer" class="dialog-footer" v-if="formStatus==1">
      <el-button @click="cancel">取消</el-button>
      <el-button
        type="primary"
        @click="submitForm"
        :loading="loading"
        element-loading-text="提交中..."
        element-loading-spinner="el-icon-loading"
        element-loading-background="rgba(0, 0, 0, 0.8)"
      > 
        {{ loading ? '提交中...' : '保存' }}
      </el-button>
    </span>
    <!-- 添加或修改对话框 End -->
  </el-dialog>
</template>

<script>
import { 
  getTableDeatilsByIdApi,
  updateTableApi,
  addTableApi
 } from '@/api/CURD'
import Editor from "@/components/Editor";
export default {
  name: "addAndEdit",
  dicts: ['tourism_attractionInfoIntroduce_type'],
  components: {Editor},
  data() {
    return {
      title: "",
      model: "", // EDIT: 编辑模式 ADD : 新增模式  EDITInit : 编辑模式（需要请求详情）
      open: false,
      loading: false,
      loadingText: "拼命加载数据中...",
      formStatus: null, // 0/null : 加载中 1 : 获取详情成功 2  : 获取详情失败 
      configUrl: {
        add: '/merchant/merchantDetail/insertOrUpdate', // 新增地址
        details: '/merchant/merchantDetail/selectById', // 详情地址
        edit: '/merchant/merchantDetail/insertOrUpdate', // 编辑地址
      },
      form: {
        id: undefined,
      },
      rules: {
        titleName: [{ required: true, message: "请输入标题名称", trigger: ["change","blur"] }],
        contentMain: [{ required: true, message: "请输入内容摘要", trigger: ["change","blur"] }],
        imgUrl: [{ required: true, message: "请上传封面上传图片", trigger: ["change","blur"] }],
        photos: [{ required: true, message: "请上传景区相册图片", trigger: ["change","blur"] }],
        contentType: [{ required: true, message: "请选择内容类型", trigger: ["change","blur"] }],
        content: [{ required: true, message: "请输入内容", trigger: ["change","blur"] }],
      },
      scenicAreaProducts: [],// 景点产品关联
      //  上传文件
      actionUrl: process.env.VUE_APP_BASE_API + process.env.VUE_APP_UPLOAD_IMAGE,
      actionUrlLoading: false,
      actionUrlMoreLoading: false,
    };
  },
  methods: {
    async initData(title , model,row){
      this.title = title
      this.open = true
      this.loadingText = "拼命加载数据中..."
      this.loading = true
      this.actionUrlLoading = false
      this.actionUrlMoreLoading = false
      this.model = model
      this.formStatus = 0
      if(model=='ADD') { // 新增
        this.$set(this,'form',{...row,photos:[],imgUrl:[]})
        this.formStatus = 1
      }else if(model=='EDIT') { // 新增
        let obj = {
          ...row,
          photos: row.photos?row.photos.split(','):[],
          imgUrl: row.imgUrl?row.imgUrl.split(','):[]
        }
        this.$set(this,'form',obj)
        this.formStatus = 1
      }else if(model=='EDITInit') { // 新增
        await this.getTableDeatilsFun(row)
      }
      this.loading = false
      this.$nextTick(()=>{
        if(this.$refs["form"]) {
          this.$refs["form"].clearValidate();
        }
      })
    },
    /** 获取详情 */
    async getTableDeatilsFun(row) {
      const id = row.id
      this.loading = true
      try {
        let res = await getTableDeatilsByIdApi(this.configUrl.details,{id})
        if(res.code == 200) {
          let obj = {
            ...res.data,
            photos: res.data.photos?res.data.photos.split(','):[],
            imgUrl: res.data.imgUrl?res.data.imgUrl.split(','):[]
          }
          this.$set(this,'form',JSON.parse(JSON.stringify(obj)))
          this.formStatus = 1
        }else {
          this.$message.error('获取详情失败!!!');
          this.formStatus = 2
          this.loading = false
          this.open = false;
        }
        this.loading = false
      } catch (error) {
        console.error('获取详情失败!!!!',error)
        this.formStatus = 2
        this.loading = false
        this.open = false;
      }
    },
    /**
     * 保存
     * @date 2023-11-22
     * @returns {any}
     */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.loadingText = "提交数据中..."
          this.loading = true
          if (this.model != 'ADD') {
            addTableApi(
              this.configUrl.edit,{
                type: 1,
                ...this.form,
                imgUrl: this.form.imgUrl ? this.form.imgUrl.join(','):'',
                photos: this.form.photos ? this.form.photos.join(','):''
              }).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.loading = false
              this.open = false;
              this.$emit('refresh')
            }).catch(()=>{
              this.$message.error("修改失败!!!");
              this.loading = false
            })
          } else {
            addTableApi(this.configUrl.edit,{
                type: 1,
                ...this.form,
                imgUrl: this.form.imgUrl ? this.form.imgUrl.join(','):'',
                photos: this.form.photos ? this.form.photos.join(','):''
              }).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.loading = false
              this.open = false;
              this.$emit('refresh')
            }).catch(()=>{
              this.$message.error("新增失败!!!");
              this.loading = false
            })
          }
        }
      });
    },
    /**
     * 重置
     * @date 2023-11-22
     * @returns {any}
     */
    reset() {
      if(this.$refs["form"]) {
        this.$refs["form"].clearValidate();
      }
    },
    /**
     * 关闭弹框
     * @date 2023-11-22
     * @returns {any}
     */
    cancel() {
      this.reset();
      this.open = false;
    },

    /**  切换内容 */
    setContentType(){
      this.$set(this.form,'content','')
    },

    /**  上传图片 单张  */
    handleAvatarSuccess(response, file, fileList) {
      console.log("res, file",response, file, fileList)
      this.actionUrlLoading = false
      if(response.code == 200) {
        this.form.imgUrl.push(response.data.url)
      }
    },
    beforeAvatarUpload(file) {
      const isLt2M = file.size / 1024 / 1024 < 1;
      let testmsg = file.name.substring(file.name.lastIndexOf('.')+1)
      let typeList = ['png','jepg','jpg','gif']
      const isJPG = typeList.includes(testmsg);
      if (!isJPG) {
        this.$message.error(`上传图片图片只能是 ${typeList} 格式!`);
      }
      if (!isLt2M) {
        this.$message.error('上传图片图片大小不能超过 1MB!');
      }
      return isJPG && isLt2M;
    },
    handleAvatarProgress(){
      this.actionUrlLoading = true
    },
    handleAvatarError() {
      this.actionUrlLoading = false
    },
    handleRemove(index) {
      this.form.imgUrl.splice(index,1)
    },
    /**  上传图片 多张  */
    beforeAvatarUploadMore(file) {
      const isLt2M = file.size / 1024 / 1024 < 1;
      let testmsg = file.name.substring(file.name.lastIndexOf('.')+1)
      let typeList = ['png','jepg','jpg','gif']
      const isJPG = typeList.includes(testmsg);
      if (!isJPG) {
        this.$message.error(`上传图片图片只能是 ${typeList} 格式!`);
      }
      if (!isLt2M) {
        this.$message.error('上传图片图片大小不能超过 1MB!');
      }
      return isJPG && isLt2M;
    },
    handleAvatarSuccessMore(response, file, fileList) {
      console.log("res, file===",response, file, fileList)
      this.actionUrlMoreLoading = false
      if(response.code == 200) {
        this.form.photos.push(response.data.url)
      }
      // if(res.code != 200) {
      //   this.$set(this.form,'photos',null) 
      // }else {
      //   this.$set(this.form,'photos',res.data.url) 
      // }
      
    },
    handleRemoveMore(index) {
      this.form.photos.splice(index,1)
    },
    handleAvatarProgressMore(){
      this.actionUrlMoreLoading = true
    },
    handleAvatarErrorMore() {
      this.actionUrlMoreLoading = false
    },
  },
};
</script>

<style lang="scss" scoped>
.form-dialog-box {
  padding: 0 30px;
  padding: 0 30px;
  min-height: 50vh;
  max-height: 65vh;
  overflow-y: auto;
  >div {
    width: 100%;
    min-height: 50vh;
  }
  .form-title {
    padding: 0 0 10px 0;
    span {
      display: flex;
      color: rgba(65,80,88,1);
      font-size: 16px;
      font-family: SourceHanSansSC;
      font-weight: 700;
      line-height: 23px;
      border-left: 4px solid rgb(22, 132, 252);
      padding-left: 10px;
    }
    
  }
  ::v-deep .ql-editor {
    height: 400px;
  }
  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}
.el-table{
  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}

.area-container {
  min-height: 400px;
}

::v-deep .area-wrap-city.el-cascader {
  line-height: normal;
  .el-input {
    cursor: pointer;
    width: 100% !important;
    height: 28px !important;
    .el-input__inner {
      display: none !important;
    }
    span.el-input__suffix {
      position: inherit !important;
      i.el-input__icon {
        line-height: inherit;
        margin-left: 5px;
      }
    }

    .el-input__wrapper {
      box-shadow: none;
      input {
        display: none;
      }
    }
  }

  .el-cascader__tags {
    display: none;
  }
}

.area-city-popper {
  .el-cascader-panel {
    .el-scrollbar.el-cascader-menu {
      .el-cascader-menu__wrap.el-scrollbar__wrap {
        height: 315px;
      }
    }
  }
}

::v-deep .avatar-uploader .el-upload {
    border: 1px dashed #d9d9d9;
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
  }
  ::v-deep .avatar-uploader .el-upload:hover {
    border-color: #409EFF;
  }
  ::v-deep .avatar-uploader-icon {
    font-size: 28px;
    color: #8c939d;
    width: 100px;
    height: 100px;
    line-height: 100px;
    text-align: center;
  }
  ::v-deep .avatar {
    width: 100px;
    height: 100px;
    display: block;
  }
</style>
<style>
.custom-class-box {
  z-index: 999999 !important;
}
</style>